#line 16 "cam.nw"
#define SAVE_RET0()		SAVE_RET(0, ())
#define SAVE_RET1(x)		SAVE_RET(1, (x))
#define SAVE_RET2(x,y)		SAVE_RET(2, (x,y))
#define SAVE_RET3(x,y,z)	SAVE_RET(3, (x,y,z))
#define SAVE_RET4(x,y,z,t)	SAVE_RET(4, (x,y,z,t))

#define SAVE_RET(n,args) {	       \
	CHECK_STACK(n+1);	       \
	regs.sp -= n+1;		       \
	DO_SAVE_RET_##n args;	       \
	regs.sp[n] = (Node *)regs.ret; \
    }

#define DO_SAVE_RET_0()		/* empty */
#define DO_SAVE_RET_1(x)	DO_SAVE_RET_0();      regs.sp[0] = (x)
#define DO_SAVE_RET_2(x,y)	DO_SAVE_RET_1(x);     regs.sp[1] = (y)
#define DO_SAVE_RET_3(x,y,z)	DO_SAVE_RET_2(x,y);   regs.sp[2] = (z)
#define DO_SAVE_RET_4(x,y,z,t)	DO_SAVE_RET_3(x,y,z); regs.sp[3] = (t)

#line 41 "cam.nw"
#define SAVE_REGS(n)	SAVE_REGS_##n
#define SAVE_REGS_0	SAVE_RET0()
#define SAVE_REGS_1	SAVE_RET1(regs.r[1])
#define SAVE_REGS_2	SAVE_RET2(regs.r[1], regs.r[2])
#define SAVE_REGS_3	SAVE_RET3(regs.r[1], regs.r[2], regs.r[3])
#define SAVE_REGS_4	SAVE_RET4(regs.r[1], regs.r[2], regs.r[3], regs.r[4])

#line 61 "cam.nw"
#define EXEC0(f)		DO_EXEC(0,f,())
#define EXEC1(f,x)		DO_EXEC(1,f,(x))
#define EXEC2(f,x,y)		DO_EXEC(2,f,(x,y))
#define EXEC3(f,x,y,z)		DO_EXEC(3,f,(x,y,z))
#define EXEC4(f,x,y,z,t)	DO_EXEC(4,f,(x,y,z,t))

#define DO_EXEC(n,f,args) do { \
	DO_LOAD_REGS_##n args; \
	GOTO_INDIR(f);	       \
    } while ( 0 )

#define DO_LOAD_REGS_0()	/* empty */
#define DO_LOAD_REGS_1(x)	DO_LOAD_REGS_0();      regs.r[0] = (x)
#define DO_LOAD_REGS_2(x,y)	DO_LOAD_REGS_1(x);     regs.r[1] = (y)
#define DO_LOAD_REGS_3(x,y,z)   DO_LOAD_REGS_2(x,y);   regs.r[2] = (z)
#define DO_LOAD_REGS_4(x,y,z,t)	DO_LOAD_REGS_3(x,y,z); regs.r[3] = (t)

#line 86 "cam.nw"
#define RET(x)			EXEC1(regs.ret, x)
#define ENT(x)			EXEC1((x)->info->eval, x)

#line 103 "cam.nw"
#define CALL0(f,k)		DO_CALL(GOTO,0,f,k,())
#define CALL1(f,k,x)		DO_CALL(GOTO,1,f,k,(x))
#define CALL2(f,k,x,y)		DO_CALL(GOTO,2,f,k,(x,y))
#define CALL3(f,k,x,y,z)	DO_CALL(GOTO,3,f,k,(x,y,z))
#define CALL4(f,k,x,y,z,t)	DO_CALL(GOTO,4,f,k,(x,y,z,t))

#define CALL_INDIR0(f,k)	 DO_CALL(GOTO_INDIR,0,f,k,())
#define CALL_INDIR1(f,k,x)	 DO_CALL(GOTO_INDIR,1,f,k,(x))
#define CALL_INDIR2(f,k,x,y)	 DO_CALL(GOTO_INDIR,2,f,k,(x,y))
#define CALL_INDIR3(f,k,x,y,z)	 DO_CALL(GOTO_INDIR,3,f,k,(x,y,z))
#define CALL_INDIR4(f,k,x,y,z,t) DO_CALL(GOTO_INDIR,4,f,k,(x,y,z,t))

#define DO_CALL(goto,n,f,k,args) do { \
	DO_LOAD_REGS_##n args;	      \
	regs.ret = k;		      \
	goto(f);		      \
    } while ( 0 )

#line 129 "cam.nw"
#define CALL_ENT(x,k)		CALL1((x)->info->eval, k, x)
#define CALL_INDIR_ENT(x,k)	CALL_INDIR1((x)->info->eval, k, x)

#line 145 "cam.nw"
#define CALL_RET0(f,m)		DO_CALL_RET(0,f,m,())
#define CALL_RET1(f,m,x)	DO_CALL_RET(1,f,m,(x))
#define CALL_RET2(f,m,x,y)	DO_CALL_RET(2,f,m,(x,y))
#define CALL_RET3(f,m,x,y,z)	DO_CALL_RET(3,f,m,(x,y,z))
#define CALL_RET4(f,m,x,y,z,t)	DO_CALL_RET(4,f,m,(x,y,z,t))

#define DO_CALL_RET(n,f,m,args) do {  \
	DO_LOAD_REGS_##n args;	      \
	regs.ret = (Label)regs.sp[m]; \
	regs.sp += m + 1;	      \
	GOTO(f);		      \
    } while ( 0 )

#line 166 "cam.nw"
#define RETURN(x,n) do {		 \
	Label _ret_ = (Label)regs.sp[n]; \
	regs.r[0]   = (x);		 \
	regs.sp	   += n + 1;		 \
	GOTO_INDIR(_ret_);		 \
    } while ( 0 )

#define ENTER(x,n) do {			\
	Node *node = (x);		\
	regs.r[0]  = node;		\
	regs.ret   = (Label)regs.sp[n]; \
	regs.sp	  += n + 1;		\
	GOTO(node->info->eval);		\
    } while ( 0 )

#line 192 "cam.nw"
#define EVAL(l) do {							\
    for (;;) {								\
	if ( is_tagged_ptr(regs.r[0]) )					\
	    switch ( regs.r[0]->info->kind ) {				\
	    case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue;	\
	    case LAZY_KIND: regs.ret = (l); GOTO(regs.r[0]->info->eval); \
	    }								\
	break;								\
    }									\
    GOTO_INDIR(l);							\
} while ( 0 )

#define EVAL_INDIR(l) do {						\
    for (;;) {								\
	if ( is_tagged_ptr(regs.r[0]) )					\
	    switch ( regs.r[0]->info->kind ) {				\
	    case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue;	\
	    case LAZY_KIND: regs.ret = (l); GOTO_INDIR(regs.r[0]->info->eval); \
	    }								\
	break;								\
    }									\
    GOTO_INDIR(l);							\
} while ( 0 )

#define EVAL_NODE(l) do {					     \
    for (;;) {							     \
	switch ( regs.r[0]->info->kind ) {			     \
	case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue;    \
	case LAZY_KIND: regs.ret = (l); GOTO(regs.r[0]->info->eval); \
	}							     \
	break;							     \
    }								     \
    GOTO_INDIR(l);						     \
} while ( 0 )

#define EVAL_INDIR_NODE(l) do {					     \
    for (;;) {							     \
	switch ( regs.r[0]->info->kind ) {			     \
	case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue;    \
	case LAZY_KIND: regs.ret = (l); GOTO_INDIR(regs.r[0]->info->eval); \
	}							     \
	break;							     \
    }								     \
    GOTO_INDIR(l);						     \
} while ( 0 )

#line 244 "cam.nw"
#define SWAPn(n) do {		 \
	Node *aux  = regs.r[0];	 \
	regs.r[0]  = regs.sp[n]; \
	regs.sp[n] = aux;	 \
    } while ( 0 )

#line 254 "cam.nw"
#define FAIL(msg) do {		   \
	regs.r[0] = (Node *)msg;   \
	GOTO(regs.handlers->fail); \
    } while ( 0 )

#line 270 "cam.nw"
#define MATCH_RIGID_NODE(what, l)				  \
    for (;;) {							  \
	switch ( regs.r[0]->info->kind ) {			  \
	case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue; \
	case LVAR_KIND: regs.ret = (l); GOTO(sync_var);		  \
	case what##_KIND: break;				  \
	default: invalid_arg(#l, regs.r[0]->info->kind);	  \
	}							  \
	break;							  \
    }

#if NO_POINTER_TAGS
# define MATCH_RIGID_CHAR(l)		MATCH_RIGID_NODE(CHAR, l)
# define MATCH_RIGID_INT(l)		MATCH_RIGID_NODE(INT, l)
#endif
#define MATCH_RIGID_FLOAT(l)		MATCH_RIGID_NODE(FLOAT, l)
#define MATCH_RIGID_PTR(l)		MATCH_RIGID_NODE(PTR, l)
#define MATCH_RIGID_FOREIGN_PTR(l)	MATCH_RIGID_NODE(FOREIGN_PTR, l)
#define MATCH_RIGID_DATA(l)		MATCH_RIGID_NODE(CAPP, l)
#define MATCH_RIGID_PAPP(l)		MATCH_RIGID_NODE(PAPP, l)
#define MATCH_RIGID_VECTOR(l)		MATCH_RIGID_NODE(VECTOR, l)
#define MATCH_RIGID_ABSTRACT(l)		MATCH_RIGID_NODE(ABSTRACT, l)

#if !NO_POINTER_TAGS
#define MATCH_RIGID_CHAR(l)					      \
    for (;;) {							      \
	if ( is_tagged_ptr(regs.r[0]) )				      \
	    switch ( regs.r[0]->info->kind ) {			      \
	    case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue; \
	    case LVAR_KIND: regs.ret = (l); GOTO(sync_var);	      \
	    default: invalid_arg(#l, regs.r[0]->info->kind);	      \
	    }							      \
	break;							      \
    }

# define MATCH_RIGID_INT(l)					      \
    for (;;) {							      \
	if ( is_tagged_ptr(regs.r[0]) )				      \
	    switch ( regs.r[0]->info->kind ) {			      \
	    case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue; \
	    case LVAR_KIND: regs.ret = (l); GOTO(sync_var);	      \
	    case INT_KIND: break;				      \
	    default: invalid_arg(#l, regs.r[0]->info->kind);	      \
	    }							      \
	break;							      \
    }
#endif

#define MATCH_RIGID(l)						      \
    for (;;) {							      \
	if ( is_tagged_ptr(regs.r[0]) )				      \
	    switch ( regs.r[0]->info->kind ) {			      \
	    case INDIR_KIND: regs.r[0] = regs.r[0]->n.node; continue; \
	    case LVAR_KIND: regs.ret = (l); GOTO(sync_var);	      \
	    }							      \
	break;							      \
    }
