#line 51 "prims.nw"
#define primMinInt() LONG_MIN
#define primMaxInt() LONG_MAX

#define primAddInt(x,y) (x + y)
#define primSubInt(x,y) (x - y)
#define primMulInt(x,y) (x * y)
static inline long
primDivInt(long x, long y)
{
    long q = x / y, r = x % y;
    return (y > 0 && r < 0) || (y < 0 && r > 0) ? q - 1 : q;
}
static inline long
primModInt(long x, long y)
{
    long r = x % y;
    return (y > 0 && r < 0) || (y < 0 && r > 0) ? r + y : r;
}
static inline long
primQuotInt(long x, long y)
{
    long q = x / y, r = x % y;
    return (x < 0 && r > 0) || (x > 0 && r < 0) ? q + 1 : q;
}
static inline long
primRemInt(long x, long y)
{
    long r = x % y;
    return (x < 0 && r > 0) || (x > 0 && r < 0) ? r - y : r;
}

#line 90 "prims.nw"
#define primAndInt(x,y) ((x)&(y))
#define primOrInt(x,y)  ((x)|(y))
#define primXorInt(x,y) ((x)^(y))
#define primNotInt(x)   (~(x))

#define primBitSizeInt()  (CHAR_BIT*sizeof(long))

extern long primShiftLInt(long, long);
extern long primShiftRInt(long, long);
extern long primRotateLInt(long, long);
extern long primRotateRInt(long, long);

#line 174 "prims.nw"
#define primAddFloat(x,y) (x + y)
#define primSubFloat(x,y) (x - y)
#define primMulFloat(x,y) (x * y)
#define primDivFloat(x,y) (x / y)

#define primFloat(x)  (x)
#define primTrunc(x) ((long)(x))
extern long primRound(double);

#line 206 "prims.nw"
#define primMinChar() 0
#define primMaxChar() 0x10ffff
#define primOrd(c) (c)
extern int primChr(long);

#line 234 "prims.nw"
#define primNullPtr()		0
#define primCastPtr(x)		(x)
#define primPlusPtr(x,y)	((char *)x + y)
#define primMinusPtr(x,y)	((char *)x - (char *)y)
static inline void *
primAlignPtr(void *p, long y)
{
    long r = (long)p % y;
    return (char *)p + (r > 0 ? (y < 0 ? -y : y) : 0) - r;
}

#line 250 "prims.nw"
#define primPeekChar(p)	  (*(char *)p)
#define primPeekSChar(p)  (*(signed char *)p)
#define primPeekUChar(p)  (*(unsigned char *)p)
#define primPeekShort(p)  (*(short *)p)
#define primPeekUShort(p) (*(unsigned short *)p)
#define primPeekInt(p)	  (*(int *)p)
#define primPeekUInt(p)	  (*(unsigned int *)p)
#define primPeekLong(p)	  (*(long *)p)
#define primPeekULong(p)  (*(unsigned long *)p)
#define primPeekFloat(p)  (*(float *)p)
#define primPeekDouble(p) (*(double *)p)
#define primPeekPtr(p)	  (*(void **)p)
#define primPeekFunPtr(p) (*(void (**)(void))p)

#define primPokeChar(p,c)     do { *(char *)p = c; } while ( 0 )
#define primPokeSChar(p,c)    do { *(signed char *)p = c; } while ( 0 )
#define primPokeUChar(p,c)    do { *(unsigned char *)p = c; } while ( 0 )
#define primPokeShort(p,s)    do { *(short *)p = s; } while ( 0 )
#define primPokeUShort(p,s)   do { *(unsigned short *)p = s; } while ( 0 )
#define primPokeInt(p,i)      do { *(int *)p = i; } while ( 0 )
#define primPokeUInt(p,i)     do { *(unsigned int *)p = i; } while ( 0 )
#define primPokeLong(p,l)     do { *(long *)p = l; } while ( 0 )
#define primPokeULong(p,l)    do { *(unsigned long *)p = l; } while ( 0 )
#define primPokeFloat(p,f)    do { *(float *)p = f; } while ( 0 )
#define primPokeDouble(p,d)   do { *(double *)p = d; } while ( 0 )
#define primPokePtr(p1,p2)    do { *(void **)p1 = p2; } while ( 0 )
#define primPokeFunPtr(p1,p2) do { *(void (**)(void))p1 = p2; } while ( 0 )

#line 286 "prims.nw"
#define primSizeOfChar()   sizeof(char)
#define primSizeOfShort()  sizeof(short)
#define primSizeOfInt()	   sizeof(int)
#define primSizeOfLong()   sizeof(long)
#define primSizeOfFloat()  sizeof(float)
#define primSizeOfDouble() sizeof(double)
#define primSizeOfPtr()	   sizeof(void *)
#define primSizeOfFunPtr() sizeof(void (*)(void))

#define alignment(t)	      offsetof(struct { char x; t y; }, y)
#define primAlignmentChar()   alignment(char)
#define primAlignmentShort()  alignment(short)
#define primAlignmentInt()    alignment(int)
#define primAlignmentLong()   alignment(long)
#define primAlignmentFloat()  alignment(float)
#define primAlignmentDouble() alignment(double)
#define primAlignmentPtr()    alignment(void *)
#define primAlignmentFunPtr() offsetof(struct { char x; void (*y)(void); }, y)
